<%-- $Id: edit_help.jsp 7954 2021-05-12 13:27:22Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Client"
	import="net.sf.basedb.core.Help"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.tabcontrol.TabAction"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="m" uri="/WEB-INF/menu.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.HELP;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final int clientId = Values.getInt(request.getParameter("client_id"));
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl(":Edit "+itemType);
try
{
	String title = null;
	Client client = null;
	Help help = null;
	String externalId = null;
	
	if (itemId == 0)
	{
		title = "Create help";
		cc.removeObject("item");
		client = Client.getById(dc, clientId);
		externalId = Values.getString(request.getParameter("external_id"), 
			cc.getPropertyValue("externalId"));
	}
	else
	{
		help = Help.getById(dc, itemId);
		help.checkPermission(Permission.WRITE);
		cc.setObject("item", help);
		title = "Edit help text -- " + HTML.encodeTags(help.getName());
		externalId = help.getExternalId();
	}
	
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), help);
	ExtensionsInvoker<TabAction> invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="menu.js,tabcontrol-2.js,~help.js" styles="toolbar.css,tabcontrol.css,menu.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<m:menu
			id="listtype"
			style="display: none;">			
		<m:menuitem 
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;ol&gt;"
			data-suffix="&lt;/ol&gt;"
			title="Ordered list" 
			tooltip="Insert an ordered list"
		/>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;ul&gt;"
			data-suffix="&lt;/ul&gt;"
			title="Unordered list"
			tooltip="Insert an unordered list"
		/>			
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;li&gt;"
			data-suffix="&lt;/li&gt;"
			title="List item"
			tooltip="Insert a listitem."
		/>			
		</m:menu>
		<m:menu
			id="tableitem"
			style="display: none;">
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;table&gt;"
			data-suffix="&lt;/table&gt;"
			title="Table"
			tooltip="Insert a table"
		/>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;tr&gt;"
			data-suffix="&lt;/tr&gt;"
			title="Row"
			tooltip="Insert a tablerow."
		/>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;td&gt;"
			data-suffix="&lt;/td&gt;"
			title="Cell"
			tooltip="Insert a datacell."
		/>
		</m:menu>
		<m:menu
			id="textformats"
			style="display: none;">
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;imp&gt;"
			data-suffix="&lt;/imp&gt;"
			title="Important"
			tooltip="Mark text as important"
		/>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;lbl&gt;"
			data-suffix="&lt;/lbl&gt;"
			title="Label"
			tooltip="Mark text as a label appearing in the interface."
		/>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;req&gt;"
			data-suffix="&lt;/req&gt;"
			title="Required"
			tooltip="Mark text as required user input."
		/>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;btn&gt;"
			data-suffix="&lt;/btn&gt;"
			title="Button text"
			tooltip="Mark text to symbol a button."
		/>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;mnu&gt;"
			data-suffix="&lt;/mnu&gt;"
			title="Menu text"
			tooltip="Mark text to symbol a menu."
		/>
		</m:menu>		
		<m:menu
			id="link"
			style="display: none;"
		>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="{@include "
			data-suffix="}"
			title="Insert helptext"
			tooltip="Insert another helptext in this text."
		/>		
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="{@link "
			data-suffix="}"
			title="Internal link"
			tooltip="Insert a link to another help topic."
		/>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;a&nbsp;href=&#34;&#34;&gt;"
			data-suffix="&lt;/a&gt;"
			title="External link"
			tooltip="Insert a link to an external web page."
		/>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;a&nbsp;name=&#34;&#34;&gt;"
			data-suffix="&lt;/a&gt;"
			title="Bookmark"
			tooltip="Insert a bookmark"
		/>
		</m:menu>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="help">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="client_id" value="<%=clientId%>">

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom" remember="<%=help != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Help text" helpid="help.edit">
			<table class="fullform input100 smaller">
			<tr>
				<th>Title</th>
				<td><input class="text required auto-init" type="text" name="name" data-auto-init="<%=help == null ? "focus-select" : "focus" %>"
					value="<%=HTML.encodeTags(help == null ? Values.getString(cc.getPropertyValue("name"), "New help") : help.getName())%>" 
					maxlength="<%=Help.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>External ID</th>
				<td><input class="text required" type="text" name="external_id" 
					value="<%=HTML.encodeTags(externalId)%>"
					maxlength="<%=Help.MAX_EXTERNAL_ID_LENGTH%>"></td>
				<td></td>
			</tr>		
			<tr>
				<th>Help text</th>
				<td colspan="2" style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder topborder bg-filled-50">												
						<tbl:button 
							subclass="auto-init"
							data-auto-init="enclose-selection"
							data-prefix="&lt;b&gt;"
							data-suffix="&lt;/b&gt;"
							tooltip="Bold"							
							image="text_bold.png"
						/>
						<tbl:button
							subclass="auto-init"
							data-auto-init="enclose-selection"
							data-prefix="&lt;i&gt;"
							data-suffix="&lt;/i&gt;"
							tooltip="Italic"							
							image="text_italic.png"
						/>
						<tbl:button
							subclass="auto-init"
							data-auto-init="enclose-selection"
							data-prefix="&lt;u&gt;"
							data-suffix="&lt;/u&gt;"
							tooltip="Underline"
							image="text_underline.png"
						/>											
						<tbl:button
							subclass="auto-init"
							data-auto-init="enclose-selection"
							data-prefix="&lt;h3&gt;"
							data-suffix="&lt;/h3&gt;"
							tooltip="Header 3"
							image="text_h3.png"
						/>
						<tbl:button
							subclass="auto-init"
							data-auto-init="enclose-selection"
							data-prefix="&lt;h4&gt;"
							data-suffix="&lt;/h4&gt;"
							tooltip="Header 4"
							image="text_h4.png"
						/>
						<tbl:button
							subclass="auto-init"
							data-auto-init="menu-anchor"
							data-menu-id="textformats"
							tooltip="Textstyle"
							image="text_style_edit.gif"
						/>						
						<tbl:button
							subclass="auto-init"
							data-auto-init="menu-anchor"
							data-menu-id="tableitem"
							tooltip="Table"
							image="text_table.png"
						/>
						<tbl:button
							subclass="auto-init"
							data-auto-init="menu-anchor"
							data-menu-id="listtype"
							tooltip="List"
							image="text_list.gif"
						/>
						<tbl:button
							subclass="auto-init"
							data-auto-init="enclose-selection"
							data-prefix="&lt;br&gt;"
							data-suffix=""
							tooltip="New line"
							image="text_newline.gif" 
						/>
						<tbl:button
							subclass="auto-init"
							data-auto-init="enclose-selection"
							data-prefix="&lt;p&gt;"
							data-suffix="&lt;/p&gt;"
							tooltip="New paragraph"
							image="text_paragraph.gif"
						/>			
						<tbl:button
							subclass="auto-init"
							data-auto-init="menu-anchor"
							data-menu-id="link"
							tooltip="New link"
							image="text_link.png"							
						/>					
					</tbl:toolbar>
				</td>
			</tr>
			<tr class="dynamic">
				<th class="subprompt"></th>
				<td>
					<textarea class="text" rows="8" name="description" id="description"
						><%=HTML.encodeTags(help == null ? cc.getPropertyValue("description") : help.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Help text" />
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
