<%-- $Id:edit_platform.jsp 3820 2007-10-12 10:03:18Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.PlatformFileType"
	import="net.sf.basedb.core.DataFileType"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataTypes"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.tabcontrol.TabAction"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.json.JsonConverter"
	import="net.sf.basedb.util.json.JsonUtil"
	import="org.json.simple.JSONArray"
	import="org.json.simple.JSONObject"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.PLATFORM;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final String tabId = Values.getString(request.getParameter("tab"), null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl(":Edit "+itemType);
try
{
	String title = null;
	Platform platform = null;
	boolean isFileOnly = false;
	ItemQuery<PlatformFileType> fileTypesQuery = null;
	if (itemId == 0)
	{
		title = "Create platform";
		isFileOnly = Values.getBoolean(cc.getPropertyValue("fileOnly"), isFileOnly);
		cc.removeObject("item");
	}
	else
	{
		platform = Platform.getById(dc, itemId);
		platform.checkPermission(Permission.WRITE);
		isFileOnly = platform.isFileOnly();
		cc.setObject("item", platform);
		title = "Edit platform -- " + HTML.encodeTags(platform.getName());
		fileTypesQuery = platform.getFileTypes(null, true);
		fileTypesQuery.include(Include.ALL);
		fileTypesQuery.order(Orders.asc(Hql.property("dataFileType.name")));
	}

	JSONObject jsonFileTypes = new JSONObject();
	jsonFileTypes.put("itemType", "DATAFILETYPE");
	if (fileTypesQuery != null)
	{
		jsonFileTypes.put("items", JsonUtil.toArray(fileTypesQuery.iterate(dc), new JsonConverter<PlatformFileType>() 
		{
			public Object convert(PlatformFileType ft)
			{
				JSONObject json = new JSONObject();
				DataFileType dft = ft.getDataFileType();
				boolean required = ft.isRequired();
				boolean multiple = ft.getAllowMultiple();
				int value = 0;
				if (required) value += 1;
				if (multiple) value += 2;
				json.put("id", dft.getId());
				json.put("name", dft.getName() + (required ? " [×]" : " [-]"));
				json.put("value", value);
				return json;
			}
		}));
	}

	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), platform);
	ExtensionsInvoker<TabAction> invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,linkitems-2.js,~platforms.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="platform">
		<input type="hidden" name="cmd" value="UpdateItem">

		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol"
			position="bottom" active="<%=tabId%>" remember="<%=tabId == null && platform != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Platform" helpid="platform.edit">
			<table class="fullform input100 smaller">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" data-auto-init="<%=platform == null ? "focus-select" : "focus" %>" 
					type="text" name="name" 
					value="<%=HTML.encodeTags(platform == null ? Values.getString(cc.getPropertyValue("name"), "New platform") : platform.getName())%>" 
					maxlength="<%=Platform.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<%
			if (platform == null)
			{
				// For new platforms only
				RawDataType currentRawDataType = 
					RawDataTypes.getRawDataType(cc.getPropertyValue("rawDataType"));
				if (currentRawDataType == null)
				{
					currentRawDataType = RawDataTypes.getRawDataType(cc.getRecent("RawDataType", 0));
				}
				%>
				<tr>
					<th>External ID</th>
					<td><input class="text required unchangeable" type="text" name="externalId" 
						value="<%=HTML.encodeTags(cc.getPropertyValue("externalId"))%>" 
						maxlength="<%=Platform.MAX_EXTERNAL_ID_LENGTH%>"></td>
					<td></td>
				</tr>
				<tr>
					<th>File-only</th>
					<td>
						<input class="unchangeable" type="radio" name="fileOnly" id="fileOnlyNo" value="0" 
							<%=!isFileOnly ? "checked" : ""%>><label for="fileOnlyNo">no</label>
						<input class="unchangeable" type="radio" name="fileOnly" id="fileOnlyYes" value="1" 
							<%=isFileOnly ? "checked" : ""%>><label for="fileOnlyYes">yes</label>
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Raw data type</th>
					<td>
						<select name="rawdatatype" class="required unchangeable">
						<option value="">- any -
						<%
						for (RawDataType rdt : RawDataTypes.getSortedRawDataTypes(new RawDataTypes.NameComparator()))
						{
							if (rdt.isStoredInDb())
							{
								String selected = rdt.equals(currentRawDataType) ? "selected" : "";
								%>
								<option value="<%=rdt.getId()%>" <%=selected%>><%=HTML.encodeTags(rdt.getName())%>
								<%
							}
						}
						%>
						</select>
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Channels</th>
					<td><input class="text required unchangeable" type="text" name="channels" id="channels"
						value="<%=Values.getInt(cc.getPropertyValue("channels"), 1)%>" 
						maxlength="10" style="width: 15em;"></td>
					<td></td>
				</tr>
				<%
			}
			%>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="6" name="description" id="description"
						><%=HTML.encodeTags(platform == null ? cc.getPropertyValue("description") : platform.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		
		<t:tab id="datafiles" title="Data file types"
			tooltip="Associate this platform with date file types"
			helpid="platform.edit.filetypes"
			>
			<table class="fullform input100 smaller">
			<tr class="dynamic">
				<th>Data file types</th>
				<td>
					<div class="selectionlist">
						<table>
						<tr>
							<td>
								<select name="fileTypes" id="fileTypes" 
									class="auto-init"
									data-auto-init="link-container"
									data-initial-items="[<%=HTML.encodeTags(jsonFileTypes.toJSONString()) %>]"
									size="15" multiple>
								</select>
							</td>
							<td style="vertical-align: top;">
								<base:buttongroup vertical="true">
									<base:button 
										id="btnAddFileTypes"
										subclass="leftaligned"
										style="width: 14em;"
										title="Add&nbsp;data file types&hellip;" 
										tooltip="Add more data file types to this platform"
									/>
									<base:button 
										subclass="leftaligned auto-init"
										data-auto-init="remove-link"
										data-list-id="fileTypes"
										style="width: 14em;"
										title="Remove" 
										tooltip="Remove the selected data file types"
									/>
								</base:buttongroup>
								<input type="checkbox" id="required" name="required" value="1">
									<label for="required">Required</label><br>
								<input type="checkbox" id="multiple" name="multiple" value="1">
									<label for="multiple">Allow multiple files</label>
							</td>
						</tr>
						</table>
					</div>
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
			<%if (platform == null) {%><br>
				<base:icon image="unchangeable.png" />= can't be changed later
			<%}%>
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
