<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.FileServer"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.uri.ConnectionManagerUtil"
	import="net.sf.basedb.util.uri.ConnectionManagerFactory"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.tabcontrol.TabAction"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.FILESERVER;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl(":Edit "+itemType);
try
{
	String title = null;
	FileServer server = null;

	if (itemId == 0)
	{
		title = "Create file server";
		cc.removeObject("item");
	}
	else
	{
		server = FileServer.getById(dc, itemId);
		server.checkPermission(Permission.WRITE);
		cc.setObject("item", server);
		title = "Edit file server -- " + HTML.encodeTags(server.getName());
	}
		
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), server);
	ExtensionsInvoker<TabAction> invoker = EditUtil.useEditExtensions(jspContext);
	List<ConnectionManagerFactory> cmFactories = ConnectionManagerUtil.getFactories();
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,~fileservers.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings"/></h1>
		
		<form action="index.jsp?ID=<%=ID%>&amp;cmd=UpdateItem" method="post" name="server" enctype="multipart/form-data">

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom"  remember="<%=server != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="File server" helpid="fileserver.edit">
			<table class="fullform input100 larger">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init"
					data-auto-init="<%=server == null ? "focus-select" : "focus" %>"
					type="text" name="name" 
					value="<%=HTML.encodeTags(server == null ? Values.getString(cc.getPropertyValue("name"), "New file server") : server.getName())%>" 
					maxlength="<%=FileServer.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Connection manager</th>
				<td>
					<select name="connectionManager" id="connectionManager">
					<option value="">- auto -
					<%
					String currentFactoryId = server == null ? cc.getPropertyValue("connectionManagerFactory") : server.getConnectionManagerFactoryId();
					for (ConnectionManagerFactory cmf : cmFactories)
					{
						String cmfId = cmf.getId();
						String selected = cmfId.equals(currentFactoryId) ? "selected" : "";
						%>
						<option value="<%=cmf.getId()%>" <%=selected%>><%=HTML.encodeTags(cmf.getDisplayName())%><%=cmf.useAutoDetection() ? " (•)" : "" %>
						<%
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th class="subprompt"></th>
				<td>
					<div class="messagecontainer help" style="margin: 0.5em 0px 0.5em 0px; height: <%=(int)(scale*70)%>px; overflow: auto;">
					<div id="cmf.auto.description" style="display: none;">
						Automatically select a connection manager among those 
						that supports auto-detection.
					</div>
					<%
					for (ConnectionManagerFactory cmf : cmFactories)
					{
						String cmfId = cmf.getId();
						%>
						<div id="cmf.<%=cmfId%>.description" style="display: none;">
							<%=HTML.encodeTags(cmf.getDescription())%>
						</div>
						<%
					}
					%>
					</div>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Host</th>
				<td><input class="text" type="text" name="host" 
					value="<%=HTML.encodeTags(server == null ? Values.getString(cc.getPropertyValue("host")) : server.getHost())%>" 
					maxlength="<%=FileServer.MAX_HOST_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Username</th>
				<td><input class="text" type="text" name="username" 
					value="<%=HTML.encodeTags(server == null ? Values.getString(cc.getPropertyValue("username")) : server.getUsername())%>" 
					maxlength="<%=FileServer.MAX_USERNAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Password</th>
				<td><input class="text" type="password" name="password" 
					value="" maxlength="<%=FileServer.MAX_PASSWORD_LENGTH%>" placeholder="leave empty to keep the password"></td>
				<td></td>
			</tr>
			<tr>
				<th>Root path</th>
				<td><input class="text" type="text" name="rootPath" 
					value="<%=HTML.encodeTags(server == null ? Values.getString(cc.getPropertyValue("rootPath")) : server.getRootPath())%>" 
					maxlength="<%=FileServer.MAX_ROOT_PATH_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="4" cols="40" name="description" id="description"
						><%=HTML.encodeTags(server == null ? cc.getPropertyValue("description") : server.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		<t:tab id="httpsOptions" title="HTTPS options" 
			helpid="fileserver.edit">
			
			<table class="fullform input100 larger">
			<tr class="big">
				<th>Server certificate</th>
				<td>
					<input class="text" type="file" name="server_certificate" size="40"><br>
					<input type="checkbox" name="remove_server_certificate" id="removeServerCertificate" value="1" 
						><label for="removeServerCertificate">Remove existing server certificate</label>
				
					<div class="messagecontainer help">
						A <b>server certificate</b> may be needed to access files with https on servers that
						use self-signed certificates. You may select a file containing the server's X.509 certificate
						in either binary or base64-encoded DER format. 
					</div>
				</td>
			</tr>
			<tr>
				<th>Client certificate</th>
				<td>
					<input class="text" type="file" name="client_certificate" size="40">
				</td>
			</tr>
			<tr>
				<th class="subprompt">Password</th>
				<td>
					<input class="text" type="password" name="client_certificate_password">
				</td>
			</tr>
			<tr class="dynamic">
				<th class="subprompt"></th>
				<td>
					<input type="checkbox" name="remove_client_certificate" id="removeClientCertificate" value="1" 
						><label for="removeClientCertificate">Remove existing client certificate</label>

					<div class="messagecontainer help">
						A <b>client certificate</b> may be needed to access files with https on servers
						that require client authentication using certificates. You should select a file
						containing your key in PKCS #12 format. If the file is password-protected you must
						enter the password as well.
					</div>
				</td>
			</tr>
			</table>
		</t:tab>
		<t:tab id="sshOptions" title="SSH options" 
			helpid="fileserver.edit">
			<table class="fullform input100 larger">
			<tr>
				<th>SSH fingerprint</th>
				<td><input class="text" type="text" name="sshFingerprint" 
					value="<%=HTML.encodeTags(server == null ? Values.getString(cc.getPropertyValue("sshFingerprint")) : server.getSshFingerprint())%>" 
					maxlength="<%=FileServer.FINGERPRINT_LENGTH%>">
				</td>
			</tr>
			<tr>
				<th class="subprompt">(MD5 or SHA-256)</th>
				<td>
					<div class="messagecontainer help">
						A <b>fingerprint</b> is needed to access the server with SSH. The fingerprint is
						a MD5 or SHA-256 hash of the public key. MD5 is typically formatted as pairs of 
						heaxdecimal numbers with colon separator while SHA-256 is Base64-encoded.
					</div>
				</td>
			</tr>
			<tr>
				<th>SSH private key</th>
				<td>
					<input class="text" type="file" name="ssh_private_key" size="40">
				</td>
			</tr>
			<tr>
				<th class="subprompt">Format</th>
				<td>
					<%
					String currentFormat = server == null ? cc.getPropertyValue("sshPrivateKeyFormat") : server.getSshPrivateKeyFormat();
					String[] formats = { "OpenSSH", "OpenSSHv1", "PuTTY", "PKCS5", "PKCS8" };
					%>
					<select name="ssh_private_key_format">
					<option value="">- auto -
					<%
					for (String f : formats)
					{
						%>
						<option value="<%=f%>" <%=f.equals(currentFormat) ? "selected" : "" %>><%=f%>
						<%
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th class="subprompt">Password</th>
				<td>
					<input class="text" type="password" name="ssh_private_key_password">
				</td>
			</tr>
			<tr class="dynamic">
				<th class="subprompt"></th>
				<td>
					<input type="checkbox" name="remove_ssh_private_key" id="removeSshPrivateKey" value="1" 
						><label for="removeSshPrivateKey">Remove existing private key</label>

					<div class="messagecontainer help">
						A <b>private key</b> can be used instead of a password to connect to a server.
						
						If the file is password-protected you must enter the password as well.
					</div>
				</td>
			</tr>
			
			</table>
			
		</t:tab>
		</t:tabcontrol>
		</form>

		<div class="legend">
			• = supports auto-detection<br>
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />>
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
