<%-- $Id: edit_slide.jsp 7954 2021-05-12 13:27:22Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ArraySlide"
	import="net.sf.basedb.core.ArrayBatch"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.tabcontrol.TabAction"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.ARRAYSLIDE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl(":Edit "+itemType);
try
{
	String title = null;
	ArraySlide slide = null;
	
	boolean readCurrentArrayBatch = true;
	ArrayBatch currentArrayBatch = null;
	int maxIndex = 0;
	
	// Load recently used items
	List<ArrayBatch> recentArrayBatches = cc.getRecent(dc, Item.ARRAYBATCH);

	if (itemId == 0)
	{
		title = "Create array slide";
		cc.removeObject("item");
		int arrayBatchId = Values.getInt(request.getParameter("arraybatch_id"));
		if (arrayBatchId != 0)
		{
			currentArrayBatch = ArrayBatch.getById(dc, arrayBatchId);
		}
		else if (cc.getPropertyFilter("arrayBatch.name") != null)
		{
			currentArrayBatch = Base.getFirstMatching(dc, ArrayBatch.getQuery(), "name", cc.getPropertyFilter("arrayBatch.name"));
		}
		if (currentArrayBatch != null)
		{
			maxIndex = (int)currentArrayBatch.getArraySlides().count(dc);
		}
	}
	else
	{
		slide = ArraySlide.getById(dc, itemId);
		slide.checkPermission(Permission.WRITE);
		cc.setObject("item", slide);
		title = "Edit array slide -- " + HTML.encodeTags(slide.getName());
		try
		{
			currentArrayBatch = slide.getArrayBatch();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentArrayBatch = false;
		}
	}
	
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), slide);
	ExtensionsInvoker<TabAction> invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,~slides.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="slide">
		<input type="hidden" name="cmd" value="UpdateItem">

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom" remember="<%=slide != null%>" 
			extensions="<%=invoker%>">
		<t:tab id="info" title="Array slide" helpid="arrayslide.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" data-auto-init="<%=slide == null ? "focus-select" : "focus" %>"
					type="text" name="name" 
					value="<%=HTML.encodeTags(slide == null ? Values.getString(cc.getPropertyValue("name"), "New array slide") : slide.getName())%>" 
					maxlength="<%=ArraySlide.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Barcode</th>
				<td><input class="text" type="text" name="barcode" 
					value="<%=HTML.encodeTags(slide == null ? Values.getString(cc.getPropertyValue("barcode"), "") : slide.getBarcode())%>" 
					maxlength="<%=ArraySlide.MAX_BARCODE_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th><label for="destroyed">Destroyed</label></th>
				<td><input type="checkbox" name="destroyed" id="destroyed" value="1"
					<%=(slide != null && slide.isDestroyed()) || (slide == null && Values.getBoolean(cc.getPropertyValue("destroyed"))) ? "checked" : ""%>>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Array batch</th>
				<td>
					<%
					if (slide != null)
					{
						%>
						<%=Base.getEncodedName(currentArrayBatch, !readCurrentArrayBatch)%>
						<%
					}
					else
					{
						%>
						<base:select 
							id="arraybatch_id"
							clazz="selectionlist required"
							required="true"
							current="<%=currentArrayBatch%>"
							denied="<%=!readCurrentArrayBatch%>"
							recent="<%=recentArrayBatches%>"
							newitem="true"
						/>
						<%
					}
					%>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Index</th>
				<td><input class="text" type="text" name="batch_index" id="batch_index"
					value="<%=slide == null ? Values.getInt(cc.getPropertyValue("batchIndex"), maxIndex + 1) : slide.getBatchIndex()%>" 
					maxlength="10" style="width: 15em;"></td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="6" name="description" id="description"
						><%=HTML.encodeTags(slide == null ? cc.getPropertyValue("description") : slide.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		
		<t:tab id="annotations" title="Annotations &amp; parameters" helpid="annotations.edit">
			<jsp:include page="../../common/annotations/annotate_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>
		</t:tabcontrol>
		</form>

		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
