<%-- $Id: add_members_frameset.jsp 6337 2013-10-28 15:29:30Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.10
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.ItemList"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib
	prefix="base" uri="/WEB-INF/base.tld"
%>
<%
SessionControl sc = Base.getExistingSessionControl(pageContext, true);
String ID = sc.getId();
int listId = Values.getInt(request.getParameter("list_id"));
DbControl dc = sc.newDbControl(":Add members to item list");
try
{
	ItemList list = ItemList.getById(dc, listId);
	Item memberType = list.getMemberType();
	ItemSubtype subtype = list.getItemSubtype();
	RawDataType rawDataType = list.getRawDataType();
	
	%>
	<base:page type="popup" title="Select members">
		<base:head scripts="~add_members.js" />
		<base:body>
			<h1>Select members</h1>
			
			<div id="page-data" class="datacontainer"
				data-member-type="<%=memberType.name()%>"
				data-subtype-id="<%=subtype != null ? subtype.getId() : "" %>"
				data-rawdatatype-id="<%=rawDataType != null ? rawDataType.getId() : "" %>"
			></div>
			
			<div id="f1" class="content"><iframe name="members" 
				src="" 
				class="absolutefull" style="width: 100%; height: 100%;"></iframe></div>
				
			<base:buttongroup subclass="dialogbuttons topborder">
				<base:button id="btnAddSelected" title="Add selected" />
				<base:button id="btnAddPage" title="Add current page" />
				<base:button id="btnAddAll" title="Add all" />
				<base:button id="close" title="Close" />
			</base:buttongroup>
				
			<form name="addMembers" action="index.jsp?ID=<%=ID%>" method="post" target="_top">
			<input type="hidden" name="cmd" value="AddMembers">
			<input type="hidden" name="list_id" value="<%=listId%>">
			<input type="hidden" name="which" value="">
			</form>
		</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>


